dirs = {{1,0},{0,1},{-1,0},{0,-1},{0,0}}
ndirs = {{1,0},{0,-1},{-1,0},{0,1},{0,0}}
materials = {"rock","lava","wall","ice","baba","keke","water","error","skull","grass","flag","empty","metal","heart","anni","door","key","box","all","hand","me","what","belt","anni","yes","no","hedge","orb"}

keys = 
{
	right = 0,
	up = 1,
	left = 2,
	down = 3,
	idle = 4,
	restart = 5,
	undo = 6,
	quit = 7,
	shift = 8,
}

tileslist =
{
	edge = {},
	baba = {},
	keke = {},
	rock = {},
	text_grass =
	{
		style = 0,
		name = "grass",
		type = "text",
	},
	metal = {},
	text_and =
	{
		style = 1,
		name = "and",
		type = "text",
	},
	lava = {},
	water = {},
}

tiles =
{
	["0,0"] = "edge",
	["1,0"] = "edge",
	["2,0"] = "baba",
	["3,0"] = "keke",
	["4,0"] = "rock",
	["5,0"] = "text_grass",
	["6,0"] = "metal",
	["7,0"] = "text_and",
	["8,0"] = "text_hide",
	["9,0"] = "text_follow",
	["0,1"] = "edge",
	["1,1"] = "edge",
	["2,1"] = "lava",
	["3,1"] = "water",
	["4,1"] = "wall",
	["5,1"] = "text_empty",
	["6,1"] = "text_metal",
	["7,1"] = "text_weak",
	["8,1"] = "text_back",
	["0,2"] = "text_baba",
	["1,2"] = "text_keke",
	["2,2"] = "text_flag",
	["3,2"] = "flag",
	["4,2"] = "ice",
	["5,2"] = "text_shift",
	["6,2"] = "anni",
	["7,2"] = "text_all",
	["8,2"] = "text_right",
	["0,3"] = "text_rock",
	["1,3"] = "text_lava",
	["2,3"] = "text_wall",
	["3,3"] = "text_ice",
	["4,3"] = "text_is",
	["5,3"] = "text_anni",
	["6,3"] = "text_grow",
	["7,3"] = "text_safe",
	["8,3"] = "text_up",
	["0,4"] = "text_water",
	["1,4"] = "text_win",
	["2,4"] = "text_push",
	["3,4"] = "text_stop",
	["4,4"] = "text_move",
	["5,4"] = "text_best",
	["6,4"] = "text_tele",
	["7,4"] = "hand",
	["8,4"] = "text_left",
	["0,5"] = "text_melt",
	["1,5"] = "text_hot",
	["2,5"] = "text_you",
	["3,5"] = "text_not",
	["4,5"] = "text_sink",
	["5,5"] = "heart",
	["6,5"] = "door",
	["7,5"] = "text_hand",
	["8,5"] = "text_down",
	["0,6"] = "text_hold",
	["1,6"] = "text_kill",
	["2,6"] = "skull",
	["3,6"] = "grass",
	["4,6"] = "text_skull",
	["5,6"] = "text_heart",
	["6,6"] = "text_door",
	["7,6"] = "text_text",
	["8,6"] = "text_restart",
	["0,7"] = "key",
	["1,7"] = "text_key",
	["2,7"] = "text_open",
	["3,7"] = "text_shut",
	["4,7"] = "text_in",
	["5,7"] = "box",
	["6,7"] = "text_box",
	["7,7"] = "belt",
	["8,7"] = "text_make",
	["0,8"] = "text_belt",
	["1,8"] = "me",
	["2,8"] = "text_me",
	["3,8"] = "what",
	["4,8"] = "text_what",
	["5,8"] = "text_swap",
	["6,8"] = "text_pull",
	["7,8"] = "text_on",
	["8,8"] = "text_no",
	["0,9"] = "text_yes",
	["1,9"] = "no",
	["2,9"] = "yes",
	["3,9"] = "hedge",
	["4,9"] = "text_hedge",
	["5,9"] = "text_level",
	["6,9"] = "text_orb",
	["7,9"] = "orb",
	["8,9"] = "text_bonus",
}